Index: LMDZ4/branches/V3_test/libf/dyn3dpar/nxgraro2_p.F
===================================================================
--- LMDZ4/branches/V3_test/libf/dyn3dpar/nxgraro2_p.F	(revision 708)
+++ LMDZ4/branches/V3_test/libf/dyn3dpar/nxgraro2_p.F	(revision 709)
@@ -1,3 +1,3 @@
-       SUBROUTINE nxgraro2_p (klevel,xcov, ycov, lr, grx, gry )
+       SUBROUTINE nxgraro2_p (klevel,xcov, ycov, lr, grx_out, gry_out )
 c
 c      P.Le Van .
@@ -25,14 +25,14 @@
       INTEGER klevel
       REAL xcov( ip1jmp1,klevel ), ycov( ip1jm,klevel )
-      REAL  grx( ip1jmp1,klevel ),  gry( ip1jm,klevel )
+      REAL,SAVE ::  grx( ip1jmp1,llm ),  gry( ip1jm,llm )
+      REAL  grx_out( ip1jmp1,klevel ),  gry_out( ip1jm,klevel )
 c
 c    ......   variables locales     ........
 c
-      REAL rot(ip1jm,llm) , signe, nugradrs
+      REAL,SAVE :: rot(ip1jm,llm)
+      REAL  signe, nugradrs
       INTEGER l,ij,iter,lr
 c    ........................................................
 c
-      EXTERNAL    filtreg
-      EXTERNAL  SCOPY, rotatf, nxgrad, laplacien_rotgam
       INTEGER :: ijb,ije,jjb,jje
       
@@ -47,21 +47,40 @@
       ijb=ij_begin
       ije=ij_end
-      grx(ijb:ije,1:klevel)=xcov(ijb:ije,1:klevel)
-      
+
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
+      DO    l = 1, klevel
+        grx(ijb:ije,l)=xcov(ijb:ije,l)
+      ENDDO
+c$OMP END DO NOWAIT
+
+c$OMP BARRIER
+c$OMP MASTER          
       call suspend_timer(timer_dissip)
       call exchange_Hallo(grx,ip1jmp1,llm,0,1)
       call resume_timer(timer_dissip)
+c$OMP END MASTER
+c$OMP BARRIER
 
       ijb=ij_begin
       ije=ij_end
       if(pole_sud) ije=ij_end-iip1
-      gry(ijb:ije,1:klevel)=ycov(ijb:ije,1:klevel)
+
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
+      DO    l = 1, klevel
+        gry(ijb:ije,l)=ycov(ijb:ije,l)
+      ENDDO
+c$OMP END DO NOWAIT
+ 
 c
       CALL     rotatf_p     ( klevel, grx, gry, rot )
 c      call write_field3d_p('rot1',reshape(rot,(/iip1,jjm,llm/)))
-      
+
+c$OMP BARRIER
+c$OMP MASTER      
       call suspend_timer(timer_dissip)
       call exchange_Hallo(rot,ip1jm,llm,1,1)
       call resume_timer(timer_dissip)
+c$OMP END MASTER
+c$OMP BARRIER
       
       CALL laplacien_rot_p ( klevel, rot, rot,grx,gry      )
@@ -71,7 +90,11 @@
 c
       DO  iter = 1, lr -2
+c$OMP BARRIER
+c$OMP MASTER
         call suspend_timer(timer_dissip)
 	call exchange_Hallo(rot,ip1jm,llm,1,1)
         call resume_timer(timer_dissip)
+c$OMP END MASTER
+c$OMP BARRIER
 	CALL laplacien_rotgam_p ( klevel, rot, rot )
       ENDDO
@@ -86,7 +109,11 @@
        
       CALL filtreg_p( rot, jjb,jje,jjm, klevel, 2,1, .FALSE.,1)
+c$OMP BARRIER
+c$OMP MASTER
       call suspend_timer(timer_dissip)
       call exchange_Hallo(rot,ip1jm,llm,1,0)
       call resume_timer(timer_dissip)
+c$OMP END MASTER
+c$OMP BARRIER
       CALL nxgrad_p ( klevel, rot, grx, gry )
 
@@ -94,18 +121,20 @@
       ijb=ij_begin
       ije=ij_end
-    
+      
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)    
       DO    l = 1, klevel
         
          if(pole_sud) ije=ij_end-iip1
          DO  ij = ijb, ije
-          gry( ij,l ) = gry( ij,l ) * nugradrs
+          gry_out( ij,l ) = gry( ij,l ) * nugradrs
          ENDDO
         
          if(pole_sud) ije=ij_end
          DO  ij = ijb, ije
-          grx( ij,l ) = grx( ij,l ) * nugradrs
+          grx_out( ij,l ) = grx( ij,l ) * nugradrs
          ENDDO
      
       ENDDO
+c$OMP END DO NOWAIT
 c
       RETURN
Index: LMDZ4/branches/V3_test/libf/dyn3dpar/nxgrarot_p.F
===================================================================
--- LMDZ4/branches/V3_test/libf/dyn3dpar/nxgrarot_p.F	(revision 708)
+++ LMDZ4/branches/V3_test/libf/dyn3dpar/nxgrarot_p.F	(revision 709)
@@ -1,3 +1,3 @@
-      SUBROUTINE nxgrarot_p (klevel,xcov, ycov, lr, grx, gry )
+      SUBROUTINE nxgrarot_p (klevel,xcov, ycov, lr, grx_out, gry_out )
 c   ***********************************************************
 c
@@ -26,12 +26,12 @@
       INTEGER klevel
       REAL xcov( ip1jmp1,klevel ), ycov( ip1jm,klevel )
-      REAL  grx( ip1jmp1,klevel ),  gry( ip1jm,klevel )
+      REAL  grx_out( ip1jmp1,klevel ),  gry_out( ip1jm,klevel )
+      REAL,SAVE ::  grx( ip1jmp1,llm ),  gry( ip1jm,llm )
+
 c
-      REAL rot(ip1jm,llm)
+      REAL,SAVE :: rot(ip1jm,llm)
 
       INTEGER l,ij,iter,lr
 c
-      EXTERNAL    filtreg
-      EXTERNAL       SCOPY, rotat, nXgrad
       INTEGER ijb,ije,jjb,jje
 c
@@ -42,13 +42,26 @@
       ijb=ij_begin
       ije=ij_end
-      grx(ijb:ije,1:klevel)=xcov(ijb:ije,1:klevel)
-      
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)  
+      DO l = 1, klevel
+        grx(ijb:ije,l)=xcov(ijb:ije,l)
+      ENDDO 
+c$OMP END DO NOWAIT      
+
       if(pole_sud) ije=ij_end-iip1
-      gry(ijb:ije,1:klevel)=ycov(ijb:ije,1:klevel)
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)      
+      DO l = 1, klevel
+        gry(ijb:ije,l)=ycov(ijb:ije,l)
+      ENDDO
+c$OMP END DO NOWAIT
       
       DO 10 iter = 1,lr
+c$OMP BARRIER
+c$OMP MASTER
       call suspend_timer(timer_dissip)
       call exchange_Hallo(grx,ip1jmp1,llm,0,1)
       call resume_timer(timer_dissip)
+c$OMP END MASTER
+c$OMP BARRIER
+
       CALL  rotat_p (klevel,grx, gry, rot )
 c      call write_field3d_p('rot',reshape(rot,(/iip1,jjm,llm/)))
@@ -58,22 +71,27 @@
       if (pole_sud) jje=jj_end-1
       CALL filtreg_p( rot,jjb,jje, jjm, klevel, 2,1, .false.,2)
-      
+
+c$OMP BARRIER
+c$OMP MASTER
       call suspend_timer(timer_dissip)
       call exchange_Hallo(rot,ip1jm,llm,1,0)
       call resume_timer(timer_dissip)
+c$OMP END MASTER
+c$OMP BARRIER
       
       CALL nxgrad_p (klevel,rot, grx, gry )
 c
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
       DO 5  l = 1, klevel
       if(pole_sud) ije=ij_end-iip1
       DO 2 ij = ijb, ije
-      gry( ij,l ) = - gry( ij,l ) * crot
+      gry_out( ij,l ) = - gry( ij,l ) * crot
    2  CONTINUE
       if(pole_sud) ije=ij_end
       DO 3 ij = ijb, ije
-      grx( ij,l ) = - grx( ij,l ) * crot
+      grx_out( ij,l ) = - grx( ij,l ) * crot
    3  CONTINUE
    5  CONTINUE
-
+c$OMP END DO NOWAIT
 c      call write_field3d_p('grx',reshape(grx,(/iip1,jjp1,llm/)))
 c      call write_field3d_p('gry',reshape(gry,(/iip1,jjm,llm/)))
Index: LMDZ4/branches/V3_test/libf/dyn3dpar/parallel.F90
===================================================================
--- LMDZ4/branches/V3_test/libf/dyn3dpar/parallel.F90	(revision 708)
+++ LMDZ4/branches/V3_test/libf/dyn3dpar/parallel.F90	(revision 709)
@@ -3,4 +3,5 @@
     integer, save :: mpi_size
     integer, save :: mpi_rank
+    integer, save :: COMM_LMDZ
     integer, save :: jj_begin
     integer, save :: jj_end
@@ -14,4 +15,5 @@
     integer, allocatable, save, dimension(:) :: jj_end_para
     integer, allocatable, save, dimension(:) :: jj_nb_para
+    integer, save :: OMP_CHUNK
     
  contains
@@ -19,4 +21,9 @@
     subroutine init_parallel
     USE vampir
+#ifdef CPP_COUPLE
+#ifdef CPP_PSMILE
+    USE mod_prism_proto
+#endif
+#endif
     implicit none
     
@@ -25,4 +32,5 @@
       integer :: type_size
       integer, dimension(3) :: blocklen,type
+      integer :: comp_id
       
       
@@ -30,9 +38,17 @@
 #include "dimensions90.h"
 #include "paramet90.h"
-      
+
+#ifdef CPP_COUPLE
+#ifdef CPP_PSMILE
+       call prism_init_comp_proto (comp_id, 'lmdz.x', ierr)
+       call prism_get_localcomm_proto(COMM_LMDZ,ierr)
+#endif
+#else      
       call MPI_INIT(ierr)
+      COMM_LMDZ=MPI_COMM_WORLD
+#endif
       call InitVampir
-      call MPI_COMM_SIZE(MPI_COMM_WORLD,mpi_size,ierr)
-      call MPI_COMM_RANK(MPI_COMM_WORLD,mpi_rank,ierr)
+      call MPI_COMM_SIZE(COMM_LMDZ,mpi_size,ierr)
+      call MPI_COMM_RANK(COMM_LMDZ,mpi_rank,ierr)
   
       
@@ -50,5 +66,5 @@
           print *," ---> diminuez le nombre de CPU ou augmentez la taille en lattitude"
           
-          call MPI_ABORT(MPI_COMM_WORLD,-1, ierr)
+          call MPI_ABORT(COMM_LMDZ,-1, ierr)
           
         endif
@@ -133,4 +149,9 @@
     
     subroutine Finalize_parallel
+#ifdef CPP_COUPLE
+#ifdef CPP_PSMILE
+    use mod_prism_proto
+#endif
+#endif
     implicit none
 
@@ -144,9 +165,18 @@
       deallocate(jj_end_para)
       deallocate(jj_nb_para)
-      
+
+#ifdef CPP_COUPLE
+#ifdef CPP_PSMILE
+     call prism_terminate_proto(ierr)
+     IF (ierr .ne. PRISM_Ok) THEN
+       call abort_gcm('Finalize_parallel',' Probleme dans prism_terminate_proto ',1)
+     endif
+#endif
+#else         
       call MPI_FINALIZE(ierr)
+#endif
       
     end subroutine Finalize_parallel
-    
+        
     subroutine Pack_Data(Field,ij,ll,row,Buffer)
     implicit none
@@ -217,5 +247,5 @@
       INTEGER :: Buffer_size      
       
-      call MPI_Barrier(MPI_COMM_WORLD,ierr)
+      call MPI_Barrier(COMM_LMDZ,ierr)
       call VTb(VThallo)
       
@@ -253,5 +283,5 @@
         call PACK_Data(Field(ij_begin,1),ij,ll,down,Buffer_Send_up)
         call MPI_ISSEND(Buffer_send_up,Buffer_Size,MPI_REAL8,MPI_Rank-1,1,     &
-                        MPI_COMM_WORLD,Request(NbRequest),ierr)
+                        COMM_LMDZ,Request(NbRequest),ierr)
       ENDIF
   
@@ -264,5 +294,5 @@
         
         call MPI_ISSEND(Buffer_send_down,Buffer_Size,MPI_REAL8,MPI_Rank+1,1,     &
-                        MPI_COMM_WORLD,Request(NbRequest),ierr)
+                        COMM_LMDZ,Request(NbRequest),ierr)
       ENDIF
     
@@ -274,5 +304,5 @@
               
         call MPI_IRECV(Buffer_recv_up,Buffer_size,MPI_REAL8,MPI_Rank-1,1,  &
-                        MPI_COMM_WORLD,Request(NbRequest),ierr)
+                        COMM_LMDZ,Request(NbRequest),ierr)
      
        
@@ -285,5 +315,5 @@
         
         call MPI_IRECV(Buffer_recv_down,Buffer_size,MPI_REAL8,MPI_Rank+1,1,     &
-                        MPI_COMM_WORLD,Request(NbRequest),ierr)
+                        COMM_LMDZ,Request(NbRequest),ierr)
       
         
@@ -295,5 +325,5 @@
 
       call VTe(VThallo)
-      call MPI_Barrier(MPI_COMM_WORLD,ierr)
+      call MPI_Barrier(COMM_LMDZ,ierr)
       RETURN
       
@@ -349,5 +379,5 @@
       
       call MPI_GATHERV(Buffer_send,(min(ij_end,ij)-ij_begin+1)*ll,MPI_REAL8,   &
-                        Buffer_Recv,Recv_count,displ,MPI_REAL8,rank,MPI_COMM_WORLD,ierr)
+                        Buffer_Recv,Recv_count,displ,MPI_REAL8,rank,COMM_LMDZ,ierr)
       
       if (MPI_Rank==rank) then                  
@@ -380,5 +410,5 @@
       
       call Gather_Field(Field,ij,ll,0)
-      call MPI_BCAST(Field,ij*ll,MPI_REAL8,0,MPI_COMM_WORLD)
+      call MPI_BCAST(Field,ij*ll,MPI_REAL8,0,COMM_LMDZ)
       
     end subroutine AllGather_Field
@@ -395,5 +425,5 @@
       INTEGER :: ierr
       
-      call MPI_BCAST(Field,ij*ll,MPI_REAL8,rank,MPI_COMM_WORLD)
+      call MPI_BCAST(Field,ij*ll,MPI_REAL8,rank,COMM_LMDZ)
       
     end subroutine Broadcast_Field
Index: LMDZ4/branches/V3_test/libf/dyn3dpar/pentes_ini.F
===================================================================
--- LMDZ4/branches/V3_test/libf/dyn3dpar/pentes_ini.F	(revision 708)
+++ LMDZ4/branches/V3_test/libf/dyn3dpar/pentes_ini.F	(revision 709)
@@ -56,13 +56,9 @@
       REAL      SSUM
       integer ismax,ismin,lati,latf
-      EXTERNAL  SSUM, convflu,ismin,ismax
+      EXTERNAL  SSUM, ismin,ismax
       logical first
       save first
 c   fin modif
 
-c      EXTERNAL masskg
-      EXTERNAL advx
-      EXTERNAL advy
-      EXTERNAL advz
 
 c  modif Fred 24 03 96
Index: LMDZ4/branches/V3_test/libf/dyn3dpar/ppm3d.F
===================================================================
--- LMDZ4/branches/V3_test/libf/dyn3dpar/ppm3d.F	(revision 708)
+++ LMDZ4/branches/V3_test/libf/dyn3dpar/ppm3d.F	(revision 709)
@@ -737,5 +737,5 @@
 c     j=1 c'est le pôle Sud, j=JNP c'est le pôle Nord
       Q(I,  2,k,IC) = Q(I,  1,k,IC)
-      Q(I,JMR,k,IC) = Q(I,JMP,k,IC)
+      Q(I,JMR,k,IC) = Q(I,JNP,k,IC)
 400   CONTINUE
       endif
Index: LMDZ4/branches/V3_test/libf/dyn3dpar/prather.F
===================================================================
--- LMDZ4/branches/V3_test/libf/dyn3dpar/prather.F	(revision 708)
+++ LMDZ4/branches/V3_test/libf/dyn3dpar/prather.F	(revision 709)
@@ -60,9 +60,7 @@
       REAL      SSUM
       integer ismax,ismin
-      EXTERNAL  SSUM, convflu,ismin,ismax
+      EXTERNAL  SSUM, ismin,ismax
       logical first
       save first
-      EXTERNAL advxp,advyp,advzp 
-
 
       data first/.true./
Index: LMDZ4/branches/V3_test/libf/dyn3dpar/pression_p.F
===================================================================
--- LMDZ4/branches/V3_test/libf/dyn3dpar/pression_p.F	(revision 708)
+++ LMDZ4/branches/V3_test/libf/dyn3dpar/pression_p.F	(revision 709)
@@ -29,5 +29,6 @@
       if (pole_nord) ijb=ij_begin
       if (pole_sud)  ije=ij_end
-      
+
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK) 
       DO    l    = 1, llmp1
         DO  ij   = ijb, ije
@@ -35,5 +36,5 @@
         ENDDO
       ENDDO
-   
+c$OMP END DO NOWAIT   
       RETURN
       END
Index: LMDZ4/branches/V3_test/libf/dyn3dpar/rotat_nfil_p.F
===================================================================
--- LMDZ4/branches/V3_test/libf/dyn3dpar/rotat_nfil_p.F	(revision 708)
+++ LMDZ4/branches/V3_test/libf/dyn3dpar/rotat_nfil_p.F	(revision 709)
@@ -32,5 +32,5 @@
       ije=ij_end
       if(pole_sud) ije=ij_end-iip1
-      
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)       
       DO  10 l = 1,klevel
 c
@@ -48,5 +48,5 @@
 c
   10  CONTINUE
-
+c$OMP END DO NOWAIT
       RETURN
       END
Index: LMDZ4/branches/V3_test/libf/dyn3dpar/rotat_p.F
===================================================================
--- LMDZ4/branches/V3_test/libf/dyn3dpar/rotat_p.F	(revision 708)
+++ LMDZ4/branches/V3_test/libf/dyn3dpar/rotat_p.F	(revision 709)
@@ -33,4 +33,5 @@
       if(pole_sud) ije=ij_end-iip1
       
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)      
       DO  10 l = 1,klevel
 c
@@ -48,7 +49,7 @@
 c
   10  CONTINUE
-
+c$OMP END DO NOWAIT
 ccc        CALL filtreg( rot, jjm, klevel, 2, 2, .FALSE., 1 )
-      
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)      
         DO l = 1, klevel
           DO ij = ijb, ije
@@ -56,4 +57,5 @@
           ENDDO
         ENDDO
+c$OMP END DO NOWAIT
 c
 c
Index: LMDZ4/branches/V3_test/libf/dyn3dpar/rotatf_p.F
===================================================================
--- LMDZ4/branches/V3_test/libf/dyn3dpar/rotatf_p.F	(revision 708)
+++ LMDZ4/branches/V3_test/libf/dyn3dpar/rotatf_p.F	(revision 709)
@@ -32,5 +32,6 @@
       ije=ij_end
       if(pole_sud) ije=ij_end-iip1
-      
+
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)      
       DO  10 l = 1,klevel
 c
@@ -48,10 +49,11 @@
 c
   10  CONTINUE
-
+c$OMP END DO NOWAIT
         jjb=jj_begin
         jje=jj_end
         if (pole_sud) jje=jj_end-1
         CALL filtreg_p( rot, jjb,jje,jjm, klevel, 2, 2, .FALSE., 1 )
-      
+
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)       
         DO l = 1, klevel
           DO ij = ijb, ije
@@ -59,4 +61,5 @@
           ENDDO
         ENDDO
+c$OMP END DO NOWAIT
 c
 c
Index: LMDZ4/branches/V3_test/libf/dyn3dpar/times.F90
===================================================================
--- LMDZ4/branches/V3_test/libf/dyn3dpar/times.F90	(revision 708)
+++ LMDZ4/branches/V3_test/libf/dyn3dpar/times.F90	(revision 709)
@@ -148,8 +148,8 @@
     
     tmp_table(:,:)=timer_table(:,:,mpi_rank)
-    call mpi_allgather(tmp_table(1,1),data_size,MPI_REAL8,timer_table(1,1,mpi_rank),data_size,MPI_REAL8,MPI_COMM_WORLD,ierr)
+    call mpi_allgather(tmp_table(1,1),data_size,MPI_REAL8,timer_table(1,1,mpi_rank),data_size,MPI_REAL8,COMM_LMDZ,ierr)
 
     tmp_table(:,:)=timer_table_sqr(:,:,mpi_rank)
-    call mpi_allgather(tmp_table(1,1),data_size,MPI_REAL8,timer_table_sqr(1,1,mpi_rank),data_size,MPI_REAL8,MPI_COMM_WORLD,ierr)
+    call mpi_allgather(tmp_table(1,1),data_size,MPI_REAL8,timer_table_sqr(1,1,mpi_rank),data_size,MPI_REAL8,COMM_LMDZ,ierr)
     
     deallocate(tmp_table)
@@ -176,11 +176,11 @@
 
     tmp_table(:,:)=timer_average(:,:,mpi_rank)
-    call mpi_allgather(tmp_table(1,1),data_size,MPI_REAL8,timer_average(1,1,0),data_size,MPI_REAL8,MPI_COMM_WORLD,ierr)
+    call mpi_allgather(tmp_table(1,1),data_size,MPI_REAL8,timer_average(1,1,0),data_size,MPI_REAL8,COMM_LMDZ,ierr)
 
     tmp_table(:,:)=timer_delta(:,:,mpi_rank)
-    call mpi_allgather(tmp_table(1,1),data_size,MPI_REAL8,timer_delta(1,1,0),data_size,MPI_REAL8,MPI_COMM_WORLD,ierr)
+    call mpi_allgather(tmp_table(1,1),data_size,MPI_REAL8,timer_delta(1,1,0),data_size,MPI_REAL8,COMM_LMDZ,ierr)
 
     tmp_iter(:,:)=timer_iteration(:,:,mpi_rank)
-    call mpi_allgather(tmp_iter(1,1),data_size,MPI_INTEGER,timer_iteration(1,1,0),data_size,MPI_INTEGER,MPI_COMM_WORLD,ierr)
+    call mpi_allgather(tmp_iter(1,1),data_size,MPI_INTEGER,timer_iteration(1,1,0),data_size,MPI_INTEGER,COMM_LMDZ,ierr)
     
     deallocate(tmp_table)
Index: LMDZ4/branches/V3_test/libf/dyn3dpar/tourpot_p.F
===================================================================
--- LMDZ4/branches/V3_test/libf/dyn3dpar/tourpot_p.F	(revision 708)
+++ LMDZ4/branches/V3_test/libf/dyn3dpar/tourpot_p.F	(revision 709)
@@ -31,6 +31,4 @@
       INTEGER l, ij ,ije,ijb,jje,jjb
 
-      EXTERNAL filtreg_p
-
 
       ijb=ij_begin-iip1
@@ -45,5 +43,5 @@
 
 c    ........  Calcul du rotationnel du vent V  puis filtrage  ........
-
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
       DO 5 l = 1,llm
 
@@ -65,5 +63,5 @@
 
    5  CONTINUE
-
+c$OMP END DO NOWAIT
       jjb=jj_begin-1
       jje=jj_end
@@ -73,5 +71,5 @@
       CALL  filtreg_p( rot, jjb,jje,jjm, llm, 2, 1, .FALSE., 1 )
 
-     
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)     
       DO 10 l = 1, llm
       
@@ -91,5 +89,5 @@
 
   10  CONTINUE
-
+c$OMP END DO NOWAIT
       RETURN
       END
Index: LMDZ4/branches/V3_test/libf/dyn3dpar/vitvert_p.F
===================================================================
--- LMDZ4/branches/V3_test/libf/dyn3dpar/vitvert_p.F	(revision 708)
+++ LMDZ4/branches/V3_test/libf/dyn3dpar/vitvert_p.F	(revision 709)
@@ -38,5 +38,5 @@
       
       if (pole_sud) ije=ij_end
-      
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)      
       DO 2  l = 1,llmm1
 
@@ -46,9 +46,11 @@
 
    2  CONTINUE
-
+c$OMP END DO
+c$OMP MASTER
       DO 5 ij  = ijb,ije
       w(ij,1)  = 0.
 5     CONTINUE
-
+c$OMP END MASTER
+c$OMP BARRIER
       RETURN
       END
Index: LMDZ4/branches/V3_test/libf/dyn3dpar/vlsplt_p.F
===================================================================
--- LMDZ4/branches/V3_test/libf/dyn3dpar/vlsplt_p.F	(revision 708)
+++ LMDZ4/branches/V3_test/libf/dyn3dpar/vlsplt_p.F	(revision 709)
@@ -228,26 +228,13 @@
       REAL u_mq(ip1jmp1,llm)
 
-      Logical extremum,first,testcpu
-      SAVE first,testcpu
+      Logical extremum
 
       REAL      SSUM
       EXTERNAL  SSUM
-      REAL temps0,temps1,temps2,temps3,temps4,temps5,second
-      SAVE temps0,temps1,temps2,temps3,temps4,temps5
 
       REAL z1,z2,z3
 
-      DATA first,testcpu/.true.,.false./
       INTEGER ijb,ije,ijb_x,ije_x
       
-      IF(first) THEN
-         temps1=0.
-         temps2=0.
-         temps3=0.
-         temps4=0.
-         temps5=0.
-         first=.false.
-      ENDIF
-
 c   calcul de la pente a droite et a gauche de la maille
 
@@ -265,5 +252,5 @@
 
 c   calcul de la pente aux points u
-         
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)         
          DO l = 1, llm
             
@@ -315,4 +302,5 @@
 
          ENDDO ! l=1,llm
+c$OMP END DO NOWAIT
 c	print*,'Ok calcul des pentes'
 
@@ -321,5 +309,5 @@
 c   Pentes produits:
 c   ----------------
-
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
          DO l = 1, llm
             DO ij=ijb,ije-1
@@ -342,20 +330,20 @@
 
          ENDDO
-
+c$OMP END DO NOWAIT
       ENDIF ! (pente_max.lt.-1.e-5)
 
 c   bouclage de la pente en iip1:
 c   -----------------------------
-
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
       DO l=1,llm
          DO ij=ijb+iip1-1,ije,iip1
             dxq(ij-iim,l)=dxq(ij,l)
          ENDDO
-         DO ij=1,ip1jmp1
+         DO ij=ijb,ije
             iadvplus(ij,l)=0
          ENDDO
 
       ENDDO
-
+c$OMP END DO NOWAIT
 c	 print*,'Bouclage en iip1'
 
@@ -363,5 +351,5 @@
 
 #ifdef CRAY
-
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
       DO l=1,llm
        DO ij=ijb,ije-1
@@ -377,9 +365,10 @@
        ENDDO
       ENDDO
+c$OMP END DO NOWAIT
 #else
 c   on cumule le flux correspondant a toutes les mailles dont la masse
 c   au travers de la paroi pENDant le pas de temps.
 c	print*,'Cumule ....'
-
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
       DO l=1,llm
        DO ij=ijb,ije-1
@@ -394,4 +383,5 @@
        ENDDO
       ENDDO
+c$OMP END DO NOWAIT
 #endif
 c	stop
@@ -400,4 +390,5 @@
 c   detection des points ou on advecte plus que la masse de la
 c   maille
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
       DO l=1,llm
          DO ij=ijb,ije-1
@@ -408,5 +399,7 @@
          ENDDO
       ENDDO
+c$OMP END DO NOWAIT
 c	print*,'Ok test 1'
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
       DO l=1,llm
        DO ij=ijb+iip1-1,ije,iip1
@@ -414,4 +407,5 @@
        ENDDO
       ENDDO
+c$OMP END DO NOWAIT
 c	 print*,'Ok test 2'
 
@@ -424,4 +418,5 @@
 
       n0=0
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
       DO l=1,llm
          nl(l)=0
@@ -431,11 +426,11 @@
          n0=n0+nl(l)
       ENDDO
-
+c$OMP END DO NOWAIT
 cym      IF(n0.gt.1) THEN
-      IF(n0.gt.0) THEN
+cym      IF(n0.gt.0) THEN
 
 c      PRINT*,'Nombre de points pour lesquels on advect plus que le'
 c     &       ,'contenu de la maille : ',n0
-
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
          DO l=1,llm
             IF(nl(l).gt.0) THEN
@@ -487,5 +482,6 @@
             ENDIF
          ENDDO
-      ENDIF  ! n0.gt.0 
+c$OMP END DO NOWAIT
+cym      ENDIF  ! n0.gt.0 
 9999    continue
 
@@ -493,4 +489,5 @@
 c   bouclage en latitude
 c	print*,'Avant bouclage en latitude'
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
       DO l=1,llm
         DO ij=ijb+iip1-1,ije,iip1
@@ -498,8 +495,8 @@
         ENDDO
       ENDDO
-
+c$OMP END DO NOWAIT
 
 c   calcul des tENDances
-
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
       DO l=1,llm
          DO ij=ijb+1,ije
@@ -516,4 +513,5 @@
          ENDDO
       ENDDO
+c$OMP END DO NOWAIT
 c     CALL SCOPY((jjm-1)*llm,q(iip1+iip1,1),iip1,q(iip2,1),iip1)
 c     CALL SCOPY((jjm-1)*llm,masse(iip1+iip1,1),iip1,masse(iip2,1),iip1)
@@ -568,5 +566,7 @@
       REAL temps0,temps1,temps2,temps3,temps4,temps5,second
       SAVE temps0,temps1,temps2,temps3,temps4,temps5
+c$OMP THREADPRIVATE(temps0,temps1,temps2,temps3,temps4,temps5)
       SAVE first,testcpu
+c$OMP THREADPRIVATE(first,testcpu)
 
       REAL convpn,convps,convmpn,convmps
@@ -575,5 +575,7 @@
       REAL coslon(iip1),coslondlon(iip1)
       SAVE sinlon,coslon,sinlondlon,coslondlon
+c$OMP THREADPRIVATE(sinlon,coslon,sinlondlon,coslondlon)
       SAVE airej2,airejjm
+c$OMP THREADPRIVATE(airej2,airejjm)
 c
 c
@@ -605,5 +607,5 @@
 c	PRINT*,'CALCUL EN LATITUDE'
 
-      
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)      
       DO l = 1, llm
 c
@@ -806,4 +808,5 @@
 
       ENDDO
+c$OMP END DO NOWAIT
 
       ijb=ij_begin-iip1
@@ -812,5 +815,5 @@
       if (pole_sud)  ije=ij_end-iip1
 
-
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
       DO l=1,llm
        DO ij=ijb,ije
@@ -825,5 +828,5 @@
        ENDDO
       ENDDO
-
+c$OMP END DO NOWAIT
       
       ijb=ij_begin
@@ -832,4 +835,5 @@
       if (pole_sud)  ije=ij_end-iip1
       
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)      
       DO l=1,llm
          DO ij=ijb,ije
@@ -900,4 +904,5 @@
 c._. fin nouvelle version
       ENDDO
+c$OMP END DO NOWAIT
 
       RETURN
@@ -939,17 +944,20 @@
       INTEGER i,ij,l,j,ii
 c
-      REAL wq(ip1jmp1,llm+1),newmasse
-
-      REAL dzq(ip1jmp1,llm),dzqw(ip1jmp1,llm),adzqw(ip1jmp1,llm),dzqmax
+      REAL,SAVE :: wq(ip1jmp1,llm+1)
+      REAL newmasse
+
+      REAL,SAVE :: dzq(ip1jmp1,llm),dzqw(ip1jmp1,llm),adzqw(ip1jmp1,llm)
+      REAL dzqmax
       REAL sigw
 
       LOGICAL testcpu
       SAVE testcpu
-
+c$OMP THREADPRIVATE(testcpu)
       REAL temps0,temps1,temps2,temps3,temps4,temps5,second
       SAVE temps0,temps1,temps2,temps3,temps4,temps5
+c$OMP THREADPRIVATE(temps0,temps1,temps2,temps3,temps4,temps5)
+
       REAL      SSUM
-      EXTERNAL  SSUM, convflu
-      EXTERNAL filtreg
+      EXTERNAL  SSUM
 
       DATA testcpu/.false./
@@ -967,5 +975,6 @@
       ijb=ijb_x
       ije=ije_x
-      
+
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)      
       DO l=2,llm
          DO ij=ijb,ije
@@ -974,5 +983,7 @@
          ENDDO
       ENDDO
-
+c$OMP END DO
+
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
       DO l=2,llm-1
          DO ij=ijb,ije
@@ -991,10 +1002,13 @@
          ENDDO
       ENDDO
-
+c$OMP END DO NOWAIT
+
+c$OMP MASTER
       DO ij=ijb,ije
          dzq(ij,1)=0.
          dzq(ij,llm)=0.
       ENDDO
-
+c$OMP END MASTER
+c$OMP BARRIER
 #ifdef BIDON
       IF(testcpu) THEN
@@ -1008,4 +1022,5 @@
 c calcul de  - d( q   * w )/ d(sigma)    qu'on ajoute a  dq pour calculer dq
 
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
        DO l = 1,llm-1
          do  ij = ijb,ije
@@ -1019,10 +1034,15 @@
          ENDDO
        ENDDO
-
+c$OMP END DO NOWAIT
+
+c$OMP MASTER
        DO ij=ijb,ije
           wq(ij,llm+1)=0.
           wq(ij,1)=0.
        ENDDO
-
+c$OMP END MASTER
+c$OMP BARRIER
+
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
       DO l=1,llm
          DO ij=ijb,ije
@@ -1033,4 +1053,5 @@
          ENDDO
       ENDDO
+c$OMP END DO NOWAIT
 
 
Index: LMDZ4/branches/V3_test/libf/dyn3dpar/vlspltqs_p.F
===================================================================
--- LMDZ4/branches/V3_test/libf/dyn3dpar/vlspltqs_p.F	(revision 708)
+++ LMDZ4/branches/V3_test/libf/dyn3dpar/vlspltqs_p.F	(revision 709)
@@ -260,24 +260,9 @@
       REAL u_mq(ip1jmp1,llm)
 
-      Logical first,testcpu
-      SAVE first,testcpu
-
       REAL      SSUM
-      REAL temps0,temps1,temps2,temps3,temps4,temps5
-      SAVE temps0,temps1,temps2,temps3,temps4,temps5
-
-
-      DATA first,testcpu/.true.,.false./
+
 
       INTEGER ijb,ije,ijb_x,ije_x
       
-      IF(first) THEN
-         temps1=0.
-         temps2=0.
-         temps3=0.
-         temps4=0.
-         temps5=0.
-         first=.false.
-      ENDIF
 
 c   calcul de la pente a droite et a gauche de la maille
@@ -299,4 +284,6 @@
 
 c   calcul de la pente aux points u
+
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK) 
          DO l = 1, llm
             DO ij=ijb,ije-1
@@ -347,4 +334,5 @@
 
          ENDDO ! l=1,llm
+c$OMP END DO NOWAIT
 
       ELSE ! (pente_max.lt.-1.e-5)
@@ -352,5 +340,5 @@
 c   Pentes produits:
 c   ----------------
-
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK) 
          DO l = 1, llm
             DO ij=ijb,ije-1
@@ -373,10 +361,10 @@
 
          ENDDO
-
+c$OMP END DO NOWAIT
       ENDIF ! (pente_max.lt.-1.e-5)
 
 c   bouclage de la pente en iip1:
 c   -----------------------------
-
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
       DO l=1,llm
          DO ij=ijb+iip1-1,ije,iip1
@@ -389,12 +377,27 @@
 
       ENDDO
-      
-      if (pole_nord) iadvplus(1:iip1,1:llm)=0
-      if (pole_sud)  iadvplus(ip1jm+1:ip1jmp1,1:llm)=0
-
+c$OMP END DO NOWAIT
+      
+      if (pole_nord) THEN
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
+        DO l=1,llm      
+          iadvplus(1:iip1,l)=0
+        ENDDO
+c$OMP END DO NOWAIT
+      endif
+      
+      if (pole_sud)  THEN
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
+        DO l=1,llm 
+	  iadvplus(ip1jm+1:ip1jmp1,l)=0
+        ENDDO
+c$OMP END DO NOWAIT
+      endif
+      	
 c   calcul des flux a gauche et a droite
 
 #ifdef CRAY
 c--pas encore modification sur Qsat
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
       DO l=1,llm
        DO ij=ijb,ije-1
@@ -410,8 +413,11 @@
        ENDDO
       ENDDO
+c$OMP END DO NOWAIT
+
 #else
 c   on cumule le flux correspondant a toutes les mailles dont la masse
 c   au travers de la paroi pENDant le pas de temps.
 c   le rapport de melange de l'air advecte est min(q_vanleer, Qsat_downwind)
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
       DO l=1,llm
        DO ij=ijb,ije-1
@@ -427,4 +433,5 @@
        ENDDO
       ENDDO
+c$OMP END DO NOWAIT
 #endif
 
@@ -432,4 +439,5 @@
 c   detection des points ou on advecte plus que la masse de la
 c   maille
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
       DO l=1,llm
          DO ij=ijb,ije-1
@@ -440,4 +448,7 @@
          ENDDO
       ENDDO
+c$OMP END DO NOWAIT
+
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
       DO l=1,llm
        DO ij=ijb+iip1-1,ije,iip1
@@ -445,4 +456,5 @@
        ENDDO
       ENDDO
+c$OMP END DO NOWAIT
 
 
@@ -457,4 +469,5 @@
 
       n0=0
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
       DO l=1,llm
          nl(l)=0
@@ -464,10 +477,12 @@
          n0=n0+nl(l)
       ENDDO
-
+c$OMP END DO NOWAIT
+
+cym ATTENTION ICI en OpenMP reduction pas forcement nécessaire
 cym      IF(n0.gt.1) THEN
-        IF(n0.gt.0) THEN
+cym        IF(n0.gt.0) THEN
 ccc      PRINT*,'Nombre de points pour lesquels on advect plus que le'
 ccc     &       ,'contenu de la maille : ',n0
-
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
          DO l=1,llm
             IF(nl(l).gt.0) THEN
@@ -519,10 +534,11 @@
             ENDIF
          ENDDO
-      ENDIF  ! n0.gt.0 
+c$OMP END DO NOWAIT
+cym      ENDIF  ! n0.gt.0 
 
 
 
 c   bouclage en latitude
-
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
       DO l=1,llm
         DO ij=ijb+iip1-1,ije,iip1
@@ -530,8 +546,8 @@
         ENDDO
       ENDDO
-
+c$OMP END DO NOWAIT
 
 c   calcul des tendances
-
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
       DO l=1,llm
          DO ij=ijb+1,ije
@@ -548,5 +564,5 @@
          ENDDO
       ENDDO
-
+c$OMP END DO NOWAIT
 c     CALL SCOPY((jjm-1)*llm,q(iip1+iip1,1),iip1,q(iip2,1),iip1)
 c     CALL SCOPY((jjm-1)*llm,masse(iip1+iip1,1),iip1,masse(iip2,1),iip1)
@@ -597,9 +613,7 @@
       REAL qpns,qpsn,dyn1,dys1,dyn2,dys2,newmasse,fn,fs
 c     REAL newq,oldmasse
-      Logical first,testcpu
-      REAL temps0,temps1,temps2,temps3,temps4,temps5
-      SAVE temps0,temps1,temps2,temps3,temps4,temps5
-      SAVE first,testcpu
-
+      Logical first
+      SAVE first
+c$OMP THREADPRIVATE(first)
       REAL convpn,convps,convmpn,convmps
       REAL sinlon(iip1),sinlondlon(iip1)
@@ -607,10 +621,11 @@
       SAVE sinlon,coslon,sinlondlon,coslondlon
       SAVE airej2,airejjm
+c$OMP THREADPRIVATE(sinlon,coslon,sinlondlon,coslondlon)
+c$OMP THREADPRIVATE(airej2,airejjm)
 c
 c
       REAL      SSUM
 
-      DATA first,testcpu/.true.,.false./
-      DATA temps0,temps1,temps2,temps3,temps4,temps5/0.,0.,0.,0.,0.,0./
+      DATA first/.true./
       INTEGER ijb,ije
 
@@ -634,5 +649,5 @@
 c
 
-
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
       DO l = 1, llm
 c
@@ -833,4 +848,5 @@
 
       ENDDO
+c$OMP END DO NOWAIT
 
       ijb=ij_begin-iip1
@@ -839,4 +855,5 @@
       if (pole_sud)  ije=ij_end-iip1
 
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
       DO l=1,llm
        DO ij=ijb,ije
@@ -851,4 +868,5 @@
        ENDDO
       ENDDO
+c$OMP END DO NOWAIT
 
       ijb=ij_begin
@@ -856,5 +874,6 @@
       if (pole_nord) ijb=ij_begin+iip1
       if (pole_sud)  ije=ij_end-iip1
-      
+
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)      
       DO l=1,llm
          DO ij=ijb,ije
@@ -917,5 +936,5 @@
 c._. fin nouvelle version
       ENDDO
-
+c$OMP END DO NOWAIT
       RETURN
       END
